#include <octave/config.h>
#include <octave/defun-dld.h>
#include <octave/error.h>
#include <octave/oct-obj.h>
#include <octave/pager.h>
#include <octave/symtab.h>
#include <octave/variables.h>
#include <octave/help.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "oct-engine.h"

// DEFUN_DLD and the macros that it depends on are defined in the
// files defun-dld.h, defun.h, and defun-int.h.
DEFUN_DLD (mopen, args, nargout,
  "[msgid] = mopen(char)\n\
\n\
Use mopen to open a message queue using seed char.")
{    
    // The list of values to return.  See the declaration in oct-obj.h
    octave_value_list retval;

    // The arguments to this function are available in args.
    int nargin = args.length ();
    if (nargin > 1) {
	error ("need at most one argument");
	return retval;
    }

    char c;
    key_t key;
    int msgid;

    if (nargin == 1) c = args(0).string_value()[0];
    else c = 'A';
    if ((key = ftok("/usr/bin/octave", c)) == -1) {
	error("mxsnd: can not ftok");
	return retval;
    }
    if ((msgid = msgget(key, 0644 | IPC_CREAT)) == -1) {
	error("mxsnd: can not msgget");
	return retval;
    }
    
    retval(0) = octave_value((double)msgid);
    return retval;
}





